#include <avr/io.h>
#include <avr/interrupt.h>
#include "system.h"
#include "rs232.h"

char TX0[256],RX0[256],TX1[256],RX1[256];
SERIAL *pR0,*pR1;
char s[80];

volatile int Ticks;

void Timer0Init(void)
{
	TCCR0B = 0x00;	//stop
	ASSR  = 0x00;	//async mode
	TCNT0 = 0x80;
	OCR0A = 0xff;
	TCCR0B = BIT(CS01) | BIT(CS00); //start timer
	TIMSK0 = BIT(OCIE0A);
}

ISR(TIMER0_COMPA_vect )
{
	TCNT0 = 0x80;
	++Ticks;
}

void PortInit(void)
{
	PORTA = 0x00;
	DDRA  = 0x00;
	PORTB = 0xff;	//output port
	DDRB  = 0xff;	//output port
	PORTC = 0x00;
	DDRC  = 0x00;
	PORTD = 0x00;
	DDRD  = 0x00;
	PORTE = 0x00;
	DDRE  = 0x00;
	PORTF = 0x00;
	DDRF  = 0x00;
	PORTG = 0x00;
	DDRG  = 0x00;
}

int main()
{
	unsigned char v;
	char f;
	int c;
	int i;

	c = 0;
	PortInit();
	Timer0Init();
	pR0 = RInit(TX0,256,RX0,256,0,115200);
	pR1 = RInit(TX1,256,RX1,256,1,9600);
	sei();
	v = 1;
	f = 1;
	while(1)
	{
		if(Ticks >= 50)
		{
			++c;
			Ticks = 0;
			if(f)
			{
				v <<= 1;
				if(v & 0x80) f = 0;
			}
			else
			{
				v >>= 1;
				if(v & 0x01) f = 1;
			}
			PORTB = ~v;
			sprintf(s,"DATA = %d\r\n",c);
			for(i=0;s[i];++i)
				RPutC(pR0,s[i]);
		}
		if(RStatus(pR0))
		{
			RPutC(pR0,RGetC(pR0));
		}
	}
	return 1;
}
