#include <stdio.h>
#include <avr/interrupt.h>
#include "system.h"
#include "task.h"
#include "rs232.h"

#define STACKSIZET	320

char Stack1[STACKSIZET],Stack2[STACKSIZET],Stack3[STACKSIZET],Stack4[STACKSIZET];
TCB T1,T2,TIdle,T3;
char TX0[256],RX0[256],TX1[256],RX1[256];
SERIAL *pR0,*pR1;
char s[80];
ECB T1Sem;
ECB T2Sem;
long Idle,TaskTwoCount;

volatile int Ticks;

void Timer0Init(void)
{
	TCCR0B = 0x00;	//stop
	ASSR  = 0x00;	//async mode
	TCNT0 = 0x80;
	OCR0A = 0xff;
	TCCR0B = BIT(CS01) | BIT(CS00); //start timer
	TIMSK0 = BIT(OCIE0A);
}

void TIMER0_COMPA_vect(void) __attribute__ ((naked));
void TIMER0_COMPA_vect(void)
{
	SAVE_IRQ();
	TCNT0 = 0x80;
	++InterruptCount;
	++Ticks;
	TimerTicker();
	ExitInterrupt();
	RESTORE_IRQ();
}

void PortInit(void)
{
	PORTA = 0x00;
	DDRA  = 0x00;
	PORTB = 0xff;	//output port
	DDRB  = 0xff;	//output port
	PORTC = 0x00;
	DDRC  = 0x00;
	PORTD = 0x00;
	DDRD  = 0x00;
	PORTE = 0x00;
	DDRE  = 0x00;
	PORTF = 0x00;
	DDRF  = 0x00;
	PORTG = 0x00;
	DDRG  = 0x00;
}



void TaskOne(void* arg)
{
	unsigned char v;
	char f;
	int c;

	v = 1;
	f = 1;
	c = 0;
	while(1)
	{
		PendSemaphore(&T1Sem,50);
		++c;
		Ticks = 0;
		if(f)
		{
			v <<= 1;
			if(v & 0x80)
				f = 0;
		}
		else
		{
			v >>= 1;
			if(v & 0x01)
				f = 1;
		}
		PORTB = ~v;
//			sprintf(s,"DATA = %d\r\n",c);
//			for(i=0;s[i];++i)
//				RPutC(pR0,s[i]);
		PostSemaphore(&T2Sem,1);
	}
}

void TaskTwo(void* arg)
{
	int i;
	char sr;

	TaskTwoCount = 0;
	while(1)
	{
		PendSemaphore(&T2Sem,0);
		++TaskTwoCount;
		//it looks like sprintf really fucks things up
		sr = Disable();
		sprintf(s,"TaskTwoCount = %ld    Idle=%ld  ARG=%04x\r\n",TaskTwoCount,Idle,arg);
		Enable(sr);
		for(i=0;s[i];++i)
			RPutC(pR0,s[i]);
	}
}

void CmdTask(void *arg)
{
	int c;
	SERIAL *pP = (SERIAL *)arg;	//this is the serial port we are going to use

	while(1)
	{
		c = RGetC(pP);
		RPutC(pP,c);
	}
}

void IdleTask(void *arg)
{
	Idle = 0;
	while(1)
	{
		++Idle;
	}
}

void (*func)(void);

int main()
{
	Disable();
	PortInit();
	InitTask();
	Timer0Init();
	pR0 = RInit(TX0,256,RX0,256,0,115200);
	pR1 = RInit(TX1,256,RX1,256,1,9600);
	CreateTask(&TIdle,IdleTask,Stack3,STACKSIZET,1,"Idle",NULL);
	Insert(&ActiveTasks,&TIdle);
	CreateTask(&T1,TaskOne,Stack1,STACKSIZET,2,"T1",NULL);
	Insert(&ActiveTasks,&T1);
	CreateSemaphore(&T1Sem,0,SEMAPHORE_MODE_TIMEOUT,"T1Sem");
	CreateTask(&T2,TaskTwo,Stack2,STACKSIZET,2,"T2",(void *)0x1234);
	Insert(&ActiveTasks,&T2);
	CreateSemaphore(&T2Sem,0,SEMAPHORE_MODE_BLOCKING,"T2Sem");
	CreateTask(&T3,CmdTask,Stack4,STACKSIZET,4,"T3",(void *)pR1);
	Insert(&ActiveTasks,&T3);
	StartOS();
	while(1);
	return 0;
}
