#include <avr/io.h>

	.section .text

	.global Disable
	.global Enable

	//----------------------------------------------------
	// Disable
	//
	// 	This function disables interrupts
	//
	// return value:
	//	returns a flag to indicate state of interrupt flag
	//	before they were disabled.
	//	0    -> Interrupts were disabled
	//	0x80 -> Interrupts were enabled
	//----------------------------------------------------

Disable:

	in	r24,_SFR_IO_ADDR(SREG)		;get status register
	cli								;disable interrupt
	andi r24,0x80					;strip off interrupt bit
	ret

	//----------------------------------------------------
	// Enable
	//
	//	This function is used to enable interrupts
	//	Generally, it is passed the value that was
	//	returned by Disable
	//
	// parameters:
	//	sr.........flag to indicate how to set I bit in SREG
	//				0    -> Leave I bit alone
	//				0x80 -> Set I bit
	//				It should be noted that if any other bits
	//				are set in "sr", those flags will also be
	//				changed in SREG
	//-----------------------------------------------------
Enable:
	in r25,_SFR_IO_ADDR(SREG)
	or r25,r24
	out _SFR_IO_ADDR(SREG),r25
	ret

	.end
